/******************************************************************************
  * @file    PT32x03x_it.c
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/9/1
  * @brief    This file provides all interrupt service routine.
  *          
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/
  
/* Includes ------------------------------------------------------------------------------------------------*/
#include "PT32x033x_it.h"


/** @defgroup IT
  * @brief IT driver modules
  * @{
  */
  
/* Private typedef -----------------------------------------------------------------------------------------*/
/* Private define ------------------------------------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------------------------------------*/
/* Private functions ---------------------------------------------------------------------------------------*/



/**
* @brief NMIжϷ
* @param None
* @retval None
*/
void NMI_Handler(void)
{
}

/**
* @brief HardFaultжϷ
* @param None
* @retval None
*/
void HardFault_Handler(void)
{
  	while (1);
}

/**
* @brief SVCжϷ
* @param None
* @retval None
*/
void SVC_Handler(void)
{
}

/**
* @brief PendSVжϷ
* @param None
* @retval None
*/
void PendSV_Handler(void)
{
}

/**
* @brief SysTickжϷ
* @param None
* @retval None
*/
void SysTick_Handler(void)
{
}

/**
* @brief WWDGжϷ
* @param None
* @retval None
*/
void SWDG_Handler(void)
{
	
}

/**
* @brief CLK_FAILжϷ
* @param None
* @retval None
*/
void PLLFAIL(void)
{
	
}

/**
* @brief IFMCжϷ
* @param None
* @retval None
*/
void IFMC_Handler(void)
{
}

/**
* @brief PAжϷ
* @param None
* @retval None
*/
void EXTIA_Handler(void)
{
}

/**
* @brief PBжϷ
* @param None
* @retval None
*/
void EXTIB_Handler(void)
{
}

/**
* @brief PCжϷ
* @param None
* @retval None
*/
void EXTIC_Handler(void)
{
}

/**
* @brief PDжϷ
* @param None
* @retval None
*/
void EXTID_Handler(void)
{
	
}

/**
* @brief Comparator0жϷ
* @param None
* @retval None
*/
void CMP0_Handler(void)
{
	
}

/**
* @brief Comparator1жϷ
* @param None
* @retval None
*/
void CMP1_Handler(void)
{

}

/**
* @brief DACжϷ
* @param None
* @retval None
*/
void DAC_Handler(void)
{
}

/**
* @brief ADCжϷ
* @param None
* @retval None
*/
void ADC_Handler(void)
{
}

/**
* @brief TIMER1жϷ
* @param None
* @retval None
*/
void TIM1_Handler(void)
{
	
}

/**
* @brief TIMER0жϷ
* @param None
* @retval None
*/
extern int i_count[],j,n,i,Capture_flag,countRise,countAll;
extern u8 flag;
void TIM0_Handler(void)
{
	i_count[i]=((TIM0->ICR1)&0xffff);
	i++;
	TIM0->SR|=0x30;//ز־λ
	//ݴڲԣ˴ʹֵ˲
	for(j=0;j<100;j++);
	if(i==100)
	{
		for(j=1;j<100;j++)
		{
			for(n=0;n<j;n++)
			{
				if(i_count[j]<i_count[n])
				{
					i=i_count[j];
					i_count[j]=i_count[n];
					i_count[n]=i;
				}
			}
		}
		TIM0->CAPR&=~0x8;//رж
		PWM_Cmd(TIM0,DISABLE);
		countRise=i_count[15];
		countAll=i_count[85]+i_count[15];
		Capture_flag=1;
	}
}

/**
* @brief TIMER4жϷ
* @param None
* @retval None
*/
void TIM4_Handler(void)
{
}

/**
* @brief TIMER2жϷ
* @param None
* @retval None
*/

extern int TIM2_FLAG;
void TIM2_Handler(void)
{
	TIM2_FLAG++;
	TIM2->SR|=0x1;
}

/**
* @brief PVDжϷ
* @param None
* @retval None
*/
void PVD_Handler(void)
{
}

/**
* @brief SPI0жϷ
* @param None
* @retval None
*/
void SPI0_Handler(void)
{
}

/**
* @brief SPI1жϷ
* @param None
* @retval None
*/
void SPI1_Handler(void)
{
}

/**
* @brief UART0жϷ
* @param None
* @retval None
*/
void UART0_Handler(void)
{
	
}

/**
* @brief RTCжϷ
* @param None
* @retval None
*/
void RTC_Handler(void)
{
	
}

/**
  * @}
  */

