/******************************************************************************
  * @Example  LED
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/9/1
  * @brief   ʹø߼ʱTIM0PWMPWMͨPB4
						 ʹͨʱTIM2ΪTIM0ṩ100HzĶʱ
						 ÿ10msTIM2жϺ󣬸ıTIM0PWMռձ
						 PB4LEDƼʵֺЧ
  *          
  ******************************************************************************
  * @attention	
  *
  *
  *****************************************************************************/
#include "PT32x033x.h"


void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX0
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}
/*******************************************************************************
*Function:	TIMER_GPIO_Config
*Description:	TIMER
*Input:		
*Return:		
*Others:
			úʹTIMERģ
*******************************************************************************/
void Advanced_TIMER_GPIO_Config(void)
{
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_4, AFIO_AF_1,ENABLE);	//PB4 TIM0_CH1	
}

/*******************************************************************************
*Function:	TIMER_Mode_Config
*Description:	TIMER
*Input:		
*Return:		
*Others:
			úʼTIMERģĹ乤ʽ
*******************************************************************************/
void Advanced_TIMER_Mode_Config(void)
{
	PWM_TimeBaseInitTypeDef  TimeBaseInit;
	PWM_CaptureInitTypeDef CaptureInit;
	
	NVIC_ClearPendingIRQ(TIM0_IRQn);
	NVIC_EnableIRQ(TIM0_IRQn);

	TimeBaseInit.PWM_Period = 10000;	  
	TimeBaseInit.PWM_Prescaler = 0;		// 25/1
	TimeBaseInit.PWM_ClockSel=PCLK;
	TimeBaseInit.PWM_CounterMode = PWM_CNT_MODE_UP;	//ϼ
	TimeBaseInit.PWM_CounterDirRvEN = PWM_CounterDirRv_DIS;	//򲻱
	PMW_TimeBaseInit(TIM0, &TimeBaseInit);
	
	CaptureInit.Channel=PWM_CH_1;
	CaptureInit.CaptureMode=CHAN_CAPTURE_RiseEdage_SEL|CHAN_CAPTURE_FallingEdage_SEL|CHAN_CAPTURE_ResetTC_SEL;//ز,ʱ
	CaptureInit.Capture_Interrupt=CHAN_CAPTURE_Interrupt_Enable;
	PWM_CaptureInit(TIM0,&CaptureInit);
	
	PWM_Cmd(TIM0, ENABLE);		//ʹܶʱ
}

/*******************************************************************************
*Function:	PWM_Out_Config
*Description:	PWM
*Input:		float cmpvalue,float pwmhzռձ
*Return:		
*Others:		
*******************************************************************************/
void PWM_Out_Config(float cmpvalue,float pwmhz)
{
	PWM_TimeBaseInitTypeDef  TimeBaseInit;
	PWM_OutputInitTypeDef		OutPutInit;
	u8 CompareValue,Period,Prescaler;
	
	PWM_Cmd(TIM1, DISABLE);
	
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_7, AFIO_AF_1,ENABLE);	//PA7 TIM1_CH2	
	
	Prescaler=(clk_get_sysclk()*1.0/(pwmhz*1.0*10)+0.5)/1-1;//
	Period=9;
	CompareValue=(u32)(cmpvalue*10+0.5)/1-1;//
	
	TimeBaseInit.PWM_Period = Period;	//  PWMHz=SysHz/(Prescaler+1)/(Period+1)
	TimeBaseInit.PWM_Prescaler = Prescaler;	//SysHz/Prescaler
	TimeBaseInit.PWM_CounterMode = PWM_CNT_MODE_UP;	//ϼ
	TimeBaseInit.PWM_CounterDirRvEN = PWM_CounterDirRv_DIS;	//򲻱
	TimeBaseInit.PWM_ClockSel=PCLK;
	PMW_TimeBaseInit(TIM1, &TimeBaseInit);
	
	OutPutInit.Channel=PWM_CH_2;
	OutPutInit.OutputMode=COMPAER_MODE1;		//ֵռձƥĴֵߵƽ
	OutPutInit.ControlN=PWM_OCMR_OC1NE;	//ʹ
	OutPutInit.IdleState=PWM_IDLE_LOW;	//PWMʱ0
	OutPutInit.DeathTime=0;			//ʱ0
	OutPutInit.CompareValue=CompareValue;		//ռձ=CompareValue/(Period+1)
	PWM_OutputInit(TIM1,&OutPutInit);	
	
	PWM_Cmd(TIM1, ENABLE);		//ʹܶʱ
}

void Advanced_Timer_Init(void)
{
	Advanced_TIMER_GPIO_Config();
	Advanced_TIMER_Mode_Config();
}

void TIM_Delay(void)
{
	TIM_TimeBaseInitTypeDef  TimeBaseInit;
	NVIC_ClearPendingIRQ(TIM2_IRQn);
	NVIC_EnableIRQ(TIM2_IRQn);
	
	TimeBaseInit.MatchValue = 59999;	//  0.125/60000 200k
	TimeBaseInit.Prescaler = 199;		// 25/200=0.125MHZ
	TimeBaseInit.CounterMode = TIM_CounterMode_UP;	//ϼ
	TimeBaseInit.OVRSTEN = ENABLE;	//򲻱
	TIM_TimeBaseInit(TIM2, &TimeBaseInit);
	TIM_ITConfig(TIM2,TIMx_IE_UIE,ENABLE);
	TIM_Cmd(TIM2, ENABLE);		//ʹܶʱ
	TIM2->SR=0X1;
}

int TIM2_FLAG=0,Enq_Flag=0;
int i,j,n,Capture_flag=0,countRise=0,countAll=0;
u8 flag=2;
int i_count[100]={0};
int main (void)
{
	float PWMHz=0,CmpValue=0,PWMHz_shadow=0,CmpValue_shadow=0;
	i=0;
	Capture_flag=0;//־жϲɼ
	UART_Driver();
	TIM_Delay();
	Advanced_Timer_Init();
	while(1)
	{
		Software_Delay();
		if(TIM2_FLAG>=2)
		{
 			TIM0->CAPR|=0x8;//ж
			PWM_Cmd(TIM0, ENABLE);				
			Software_Delay();
				if(Capture_flag)//ȷPWM
			{
				PWMHz_shadow=clk_get_sysclk()*1.0/(countAll*1.0);
				CmpValue_shadow=countRise*1.0/(countAll*1.0);
				if(PWMHz!=PWMHz_shadow)
				{
					PWMHz=PWMHz_shadow;
					Enq_Flag=1;
				}
				if(CmpValue!=CmpValue_shadow)
				{
					CmpValue=CmpValue_shadow;
					Enq_Flag=1;
				}
				if(Enq_Flag)
				{
					printf("Ƶʣ%f hz,ռձȣ%f\r\n",PWMHz,CmpValue);
					Software_Delay();
					//ݼֵ				
					PWM_Out_Config(CmpValue,PWMHz);
					Enq_Flag=0;
				}
				TIM2_FLAG=0;
				Capture_flag=0;
			}
		}
	}
}
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


