  /******************************************************************************
  * @Example ADC
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ADCοѹΪVDDA
	*          ADCеתɼתΪģѹͨڴӡ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλУ
  *							
  *							
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX0
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/*******************************************************************************
*Function:	ADC_GPIO_Config
*Description:	ADC
*Input:		
*Return:		
*Others:
			úʹADCģ
*******************************************************************************/
void ADC_GPIO_Config(void)
{
	GPIO_AnaRemapConfig(AFIOC, AFIO_Pin_13, ENABLE);		//PC13ΪADCͨ
}

	void ADC_StructInit(ADC_InitTypeDef* ADC_InitStruct)
{
	ADC_InitStruct->ADC_Prescaler = ADC_CLK_DIV2;							//ADCƵ8/2=4 MHz
	ADC_InitStruct->ADC_MODE = ADC_MODE_Single;						//תģʽ
	ADC_InitStruct->ADC_TIMS=ADC_TIMS_TIM0Trgo;						//ʱԴѡTIM0¼
	ADC_InitStruct->ADC_ALIGN = ADC_DataAlign_Right;					//Ҷ
	ADC_InitStruct->ADC_Channel=ADC_Channel_0;						//ͨ0,PC13
	ADC_InitStruct->ADC_ReferencePositive= ADC_ReferencePositive_VDDA;	//ѡVDDAΪ˲οƽ
	ADC_InitStruct->ADC_AnalogChannel=ADC_AnalogChannel_BG1v2;
}

/*******************************************************************************
*Function:	ADC_Mode_Config
*Description:	ADC
*Input:		
*Return:		
*Others:
			úʼADCģĹ乤ʽ
*******************************************************************************/
void ADC_Mode_Config(void)
{
	ADC_InitTypeDef  ADC_InitStruct;
	ADC_StructInit(&ADC_InitStruct);
	ADC_Init(ADC, &ADC_InitStruct);
}


/*******************************************************************************
*Function:	ADC_Driver
*Description:	ADCģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void ADC_Driver(void)
{	
	ADC_GPIO_Config();
	ADC_Mode_Config();
}

int main (void)
{
	int Inter_adcValue;
	float temp = 0.0;
	float Volt_Read = 0.0;
	UART_Driver();
	ADC_Driver();
	
	printf("ADC is going!\r\n");

	ADC_Cmd(ADC, ENABLE);		//ADC蹦
	while(1)
	{
		while(!ADC_GetFlagStatus(ADC, ADC_SR_RDY));	//ȴADC
		ADC_ConversionConfig(ADC,ENABLE);	//ת
		while(!ADC_GetFlagStatus(ADC, ADC_SR_EOC));		//ȴADC
		Software_Delay();
		Inter_adcValue = ADC_GetConversionValue(ADC);	//ȡ
		temp = (Inter_adcValue & 0xFFF);
		temp = (temp / 4095);
		temp *= 3.3;
		Volt_Read = temp;
		printf("ѹ:%.2f\r\n",Volt_Read);
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


