/******************************************************************************
  * @Example Beep
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ͨpc2377hZҵƵʣ
  *          
  ******************************************************************************
  * @attention	
  *					ҪJ8ӿϵBEEPPC2̽
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"

void BEEP_Driver(void)
{
	Beep_InitTypeDef Beep_InitStruct;
	GPIO_DigRemapConfig(AFIOC, AFIO_Pin_2, AFIO_AF_1,ENABLE);	//PC2 Beep
	
	Beep_InitStruct.BEEP_Prescaler=10;//ԤƵ							
	Beep_InitStruct.BEEP_Subdivide=BEEP_Subdivide_X8;	//Ƶ
	Beep_Init(&Beep_InitStruct);
	Beep_Cmd(ENABLE);
}

int main (void)
{
	int i;
	BEEP_Driver();
	for(;i<100000;i++);
	Beep_Cmd(DISABLE);
	while(1);
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


