/******************************************************************************
  * @Example OPA
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief		ⲿѹͨPC2룬OPAģͨDemoԴR1R32ɵķŴ罫ⲿѹŴ
  *          	ͨʱADCÿһʱһβɼOPAѹɼֵͨڴӡ
	*   
  *          	
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλNOУ
  *							PC2ѹӦ(0V ~VDD-1.4V)/2μֲOPA
  *							
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"


void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX0
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}


/*******************************************************************************
*Function:	OPA_GPIO_Config
*Description:	OPA
*Input:		
*Return:		
*Others:
			
*******************************************************************************/

void OPA_GPIO_Config(void)
{	
	GPIO_AnaRemapConfig(AFIOB, AFIO_Pin_12, ENABLE);	//PB12ΪģͨOPA0 OUT,ADC IN4
	GPIO_AnaRemapConfig(AFIOC, AFIO_Pin_2, ENABLE);		//PC2Ϊģͨ,OPA0 P
	GPIO_AnaRemapConfig(AFIOC, AFIO_Pin_0, ENABLE);		//PC0Ϊģͨ,OPA0 N
}

/*******************************************************************************
*Function:	OPA_Mode_Config
*Description:	OPA
*Input:		
*Return:		
*Others:
			úʼOPAģĹ乤ʽ
*******************************************************************************/
void OPA_Mode_Config(void)
{
	OPA_InitTypeDef OPA;
	
	OPA_StructInit(&OPA);
	OPA.OPA_PositiveInput = OPA_PositiveInput_OPAxP;

	OPA.OPA_PowerMode = OPA_PowerMode_HighSpeed;

	OPA_Init(OPA0,&OPA);
	
	OPA_Cmd(OPA0,ENABLE);		

	OPA0_AFGndCMD(ENABLE);	//VGӵVSSA
	OPA0_AFOutputCMD(OPA0_AFOutput1,ENABLE);		//OPAӵS0(PB12)
	
}

	void ADC_StructInit(ADC_InitTypeDef* ADC_InitStruct)
{
	ADC_InitStruct->ADC_Prescaler = ADC_CLK_DIV2;							//ADCƵ8/2=4 MHz
	ADC_InitStruct->ADC_MODE = ADC_MODE_Single;						//תģʽ
	ADC_InitStruct->ADC_TIMS=ADC_TIMS_TIM0Trgo;						//ʱԴѡTIM0¼
	ADC_InitStruct->ADC_ALIGN = ADC_DataAlign_Right;					//Ҷ
	ADC_InitStruct->ADC_Channel=ADC_Channel_4;						//ͨ4
	ADC_InitStruct->ADC_ReferencePositive= ADC_ReferencePositive_VDDA;	//ѡVDDAΪ˲οƽ
	ADC_InitStruct->ADC_AnalogChannel=ADC_AnalogChannel_BG1v2;
}

/*******************************************************************************
*Function:	OPA_ADC_Config
*Description:	OPAADC
*Input:		
*Return:		
*Others:
			
*******************************************************************************/
void OPA_ADC_Config(void)
{
	ADC_InitTypeDef  ADC_InitStruct;
	ADC_StructInit(&ADC_InitStruct);
	ADC_Init(ADC, &ADC_InitStruct);
	
	ADC_Cmd(ADC, ENABLE);								//ADC蹦
	while(!ADC_GetFlagStatus(ADC, ADC_SR_RDY));	//ȴADC
}

u16 ADC_Value = 0;
int main (void)
{
	UART_Driver();
	OPA_GPIO_Config();
	OPA_Mode_Config();
	OPA_ADC_Config();
	while(1)
	{
		Software_Delay();
		ADC_Cmd(ADC, ENABLE);		//ADC蹦
		while(!ADC_GetFlagStatus(ADC, ADC_SR_RDY));	//ȴADC
		Software_Delay();
		ADC_ConversionConfig(ADC,ENABLE);	//ת
		while(!ADC_GetFlagStatus(ADC, ADC_SR_EOC));		//ȴADC
		ADC_Value = ADC_GetConversionValue(ADC);	//ȡ
		ADC_Cmd(ADC, DISABLE);
		printf("ADC Value:%d\r\n",ADC_Value);
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


