/******************************************************************************
  * @Example CMP
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ȽCOMP1ΪDACɵ0.5VddѹΪPD4ͨʱɵķ룬
	*          COMP1_OUT(PA1)PD4Եź,ػ½أRGBƻ˸
  *          
  ******************************************************************************
  * @attention	ʹø̣ҪDemoPD4PC1(COMP1_N)̽
  *							
  *							
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"


void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

void COMP_GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOD, &GPIO_InitStructure);				//PD4ΪCMPź

	GPIO_AnaRemapConfig(AFIOC, AFIO_Pin_1,ENABLE); //PC1ΪCMP1_Nͨ	
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_2,ENABLE);	//PA1ΪCMP1_OUTͨ	
}

void COMP_Driver(void)
{
	CMP_InitTypeDef CMPx_CONFIG;
	
	CMP_StructInit(&CMPx_CONFIG);
	CMPx_CONFIG.CMP_PositiveInput = CMP_PositiveInput_LDAC;
	CMPx_CONFIG.CMP_DigitalFilter = CMP_DigitalFilter_NONE;
	CMPx_CONFIG.CMP_PowerMode = ENABLE;
	CMPx_CONFIG.CMP_OutputPolarity= DISABLE;
	CMP_Init(CMP1,&CMPx_CONFIG);
	
	CMP_Cmd(CMP1,ENABLE);
	LDAC_SETData(LDAC1,0xf);
	
	CMP_ITConfig(CMP1,CMP_IT_Fall,ENABLE);
	CMP_ITConfig(CMP1,CMP_IT_Rise,ENABLE);
	NVIC_EnableIRQ(CMP1_IRQn);
}

void COMP_RUN(void)
{
		static u8 count_temp=0;
		count_temp++;
		if(count_temp==1)		//
		{
			GPIO_SetBits(GPIOD, GPIO_Pin_4);
		}
		if(count_temp==2)		//̵
		{
			count_temp=0;
			GPIO_ResetBits(GPIOD, GPIO_Pin_4);
		}
}
	

void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;	//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;	//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	//ƫ
	GPIO_Init(GPIOC, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
	GPIO_Init(GPIOC, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
	
	GPIO_SetBits(GPIOC, GPIO_Pin_5);			//ÿ⺯GPIO״̬
	
}

int main (void)
{
	LED_Driver();
	
	COMP_GPIO_Config();
	COMP_Driver();
	
	while(1)
	{
		Software_Delay();
		Software_Delay();
		COMP_RUN();
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


