/******************************************************************************
  * @file    PT32x033x_it.c
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief    This file provides all interrupt service routine.
  *          
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/
  
/* Includes ------------------------------------------------------------------------------------------------*/
#include "PT32x033x_it.h"


/** @defgroup IT
  * @brief IT driver modules
  * @{
  */
  
/* Private typedef -----------------------------------------------------------------------------------------*/
/* Private define ------------------------------------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------------------------------------*/
/* Private functions ---------------------------------------------------------------------------------------*/



/**
* @brief NMIжϷ
* @param None
* @retval None
*/
void NMI_Handler(void)
{
}

/**
* @brief HardFaultжϷ
* @param None
* @retval None
*/
void HardFault_Handler(void)
{
  	while (1);
}

/**
* @brief SVCжϷ
* @param None
* @retval None
*/
void SVC_Handler(void)
{
}

/**
* @brief PendSVжϷ
* @param None
* @retval None
*/
void PendSV_Handler(void)
{
}

/**
* @brief SysTickжϷ
* @param None
* @retval None
*/
void SysTick_Handler(void)
{
}

/**
* @brief WWDGжϷ
* @param None
* @retval None
*/
void SWDG_Handler(void)
{
	
}

/**
* @brief CLK_FAILжϷ
* @param None
* @retval None
*/
void PLLFAIL(void)
{
	
}

/**
* @brief IFMCжϷ
* @param None
* @retval None
*/
void IFMC_Handler(void)
{
}

/**
* @brief PAжϷ
* @param None
* @retval None
*/
void EXTIA_Handler(void)
{
}

/**
* @brief PBжϷ
* @param None
* @retval None
*/
void EXTIB_Handler(void)
{
}

/**
* @brief PCжϷ
* @param None
* @retval None
*/
void EXTIC_Handler(void)
{
}

/**
* @brief PDжϷ
* @param None
* @retval None
*/
void EXTID_Handler(void)
{
	
}

/**
* @brief Comparator0жϷ
* @param None
* @retval None
*/
void CMP0_Handler(void)
{
	
}

/**
* @brief Comparator1жϷ
* @param None
* @retval None
*/
void CMP1_Handler(void)
{

}

/**
* @brief DACжϷ
* @param None
* @retval None
*/
void DAC_Handler(void)
{
}

/**
* @brief ADCжϷ
* @param None
* @retval None
*/
void ADC_Handler(void)
{
}

/**
* @brief TIMER1жϷ
* @param None
* @retval None
*/
void TIM1_Handler(void)
{
	
}

/**
* @brief TIMER0жϷ
* @param None
* @retval None
*/
void TIM0_Handler(void)
{
	
}

/**
* @brief TIMER4жϷ
* @param None
* @retval None
*/
void TIM4_Handler(void)
{
	TIM_ClearFlag(TIM4, TIM_FLAG_MR0);	
}

/**
* @brief TIMER2жϷ
* @param None
* @retval None
*/
void TIM2_Handler(void)
{

}

/**
* @brief HIGH_LVDжϷ
* @param None
* @retval None
*/
void PVD_Handler(void)
{
}

/**
* @brief I2C0жϷ
* @param None
* @retval None
*/
void I2C0_Handler(void)
{
}


/**
* @brief SPI0жϷ
* @param None
* @retval None
*/
void SPI0_Handler(void)
{
}

/**
* @brief SPI1жϷ
* @param None
* @retval None
*/
void SPI1_Handler(void)
{
}

/**
* @brief UART0жϷ
* @param None
* @retval None
*/
void UART0_Handler(void)
{
	
}

/**
* @brief RTCжϷ
* @param None
* @retval None
*/
void RTC_Handler(void)
{
	
}

/**
  * @}
  */

