/******************************************************************************
  * @Example LOW_POWER
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ÿ5ҽһ˯ģʽ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλУ
  *				0ŷķR6J4ԲоƬ
  *				ʹø̲оƬʱӦþⲿ·Ķ⹦
  *				ʹø̲оƬʱӦýؿɵR290V
  *				ʹø̲оƬʱ粻ȥLEDӵR12R13R14⹦
  *				ʹø̲оƬʱ粻ȥuserӵR10⹦
  *				ʹø̲оƬʱߵӽĹ
  *				ʹ32Khzµ"TIM4"˯ߣ˯ʱ͹Ϊ2.8uA
  *				
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"

void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<50; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

void Timer4_Mode_Config(void)
{
	TIM_TimeBaseInitTypeDef TimeBaseInit;
	NVIC_InitTypeDef NVIC_InitStruct;

	/*ʹTIMER4NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = TIM4_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x03;
	NVIC_Init(&NVIC_InitStruct);
	
	/* CNTʱ = 32khz/(psc+1)*/
	TimeBaseInit.Prescaler = 127;
	TimeBaseInit.CounterMode = TIM_CNT_MODE_DOWN;
	TimeBaseInit.MatchValue = 1279;	// 10
	TimeBaseInit.OVRSTEN = ENABLE;
	TIM_TimeBaseInit(TIM4, &TimeBaseInit);
	TIM_ITConfig(TIM4, TIM_CR2_ARI, ENABLE);
	TIM_Cmd(TIM4, ENABLE);
}

void Timer4_Disable(void)
{
	TIM_ITConfig(TIM4, TIM_CR2_ARI, DISABLE);
	NVIC_DisableIRQ(TIM4_IRQn);	
	TIM_Cmd(TIM4, DISABLE);
}


void Tim4_Wake_Sleep(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	Timer4_Mode_Config();
	printf ("Sleep\r\n");
	Software_Delay();
	UART_Cmd(UART0, DISABLE);
	GPIO_AnaRemapConfig(AFIOA, AFIO_Pin_All, DISABLE);
	GPIO_AnaRemapConfig(AFIOB, AFIO_Pin_All, DISABLE);
	GPIO_AnaRemapConfig(AFIOC, AFIO_Pin_All, DISABLE);
	GPIO_AnaRemapConfig(AFIOD, AFIO_Pin_All, DISABLE);
	
	GPIO_DigRemapConfig(AFIOA, (AFIO_Pin_All&(~AFIO_Pin_13)&(~AFIO_Pin_14)),AFIO_AF_None,DISABLE);	//SWDӿڲ
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_All,AFIO_AF_None,DISABLE);
	GPIO_DigRemapConfig(AFIOC, AFIO_Pin_All,AFIO_AF_None,DISABLE);
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_All,AFIO_AF_None,DISABLE);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All&(~GPIO_Pin_3);
	GPIO_Init(GPIOD, &GPIO_InitStructure);
	
	PWR_EnterSTANDBYMode(PWR_STANDBYEntry_WFI);   //˯ߣжϻ

	Timer4_Disable();
	UART_Driver();
	printf ("Wake\r\n");
	Software_Delay();

}



int main (void)
{
	UART_Driver();
	while(1)
	{
		Tim4_Wake_Sleep();
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


