/******************************************************************************
  * @Example I2C
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ʹI2C԰eeprom,оƬͺΪK24C02
	*          д벢ݣʹôϢ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
	
  *
  *****************************************************************************/
	
#include "PT32x033x.h"


void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX0
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

void I2C_GPIO_Config(void)
{
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_0, AFIO_AF_1,ENABLE);	//SCLֹܸ
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_1, AFIO_AF_1,ENABLE);	//SDAֹܸ
}
void I2C_Driver(void)
{
	I2C->CCR=I2C_CCR_BR;
	I2C->CR|=0x00130000;
}

/**
* @brief IICд
* @param pBufferҪд
* @param WriteAddrӻַ
* @param NumByteToWriteҪдݳ
* @retval 
*/
void I2C_EE_Write(u8* pBuffer, unsigned int WriteAddr, uint16_t DeviceAddr,uint16_t data_size)
{
	int i;
	/******************ȴӻready***************/		
	I2C_GenerateSTART(I2C,DISABLE);
	I2C_AcknowledgeConfig(I2C,DISABLE);
	I2C_Cmd(I2C,DISABLE);	
	I2C_Cmd(I2C,ENABLE);
  I2C_GenerateSTART(I2C,ENABLE);
	while(I2C_GetStatus(I2C,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddr(I2C, DeviceAddr);//ַд
	while(I2C_GetStatus(I2C,I2C_FLAG_MASGetAckW)!=SET);
  /*********************************/		
	I2C_SendData(I2C, WriteAddr);
	while(I2C_GetStatus(I2C,I2C_FLAG_MDSGetAck) != SET);		
	for(i=0;i<data_size;i++)
	{
		I2C_SendData(I2C, *(pBuffer++));
		while(I2C_GetStatus(I2C,I2C_FLAG_MDSGetAck) != SET);
	}
	/******************ֹͣλ***************/
	I2C_GenerateSTOP(I2C,ENABLE);
}

/**
* @brief IIC
* @param pBuffer
* @param ReadAddrӻַ
* @param NumByteToReadݳ
* @retval 
*/
void I2C_EE_Read(u8* pBuffer, unsigned int ReadAddr,uint16_t DeviceAddr, uint16_t data_size)
{
	int i;
/******************ȴӻready***************/		
	I2C_GenerateSTART(I2C,DISABLE);
	I2C_Cmd(I2C,DISABLE);	
	I2C_Cmd(I2C,ENABLE);
  I2C_GenerateSTART(I2C,ENABLE);
	while(I2C_GetStatus(I2C,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddr(I2C, DeviceAddr);//ַд
	while(I2C_GetStatus(I2C,I2C_FLAG_MASGetAckW)!=SET);
	I2C_SendData(I2C, ReadAddr);
	while(I2C_GetStatus(I2C,I2C_FLAG_MDSGetAck) != SET);	
	I2C_GenerateSTOP(I2C,ENABLE);
/*********************************/		
  I2C_GenerateSTART(I2C,ENABLE);
	while(I2C_GetStatus(I2C,I2C_FLAG_StartOk)!= SET);
	Software_Delay();
	I2C_SendAddr(I2C, DeviceAddr|0x1);//ַ
	while(I2C_GetStatus(I2C,I2C_FLAG_MASGetAckR)!=SET);
	I2C->CCR=0x8;
	for(i=0;i<data_size;i++)
	{
		I2C->CCR=0x8;
		while(I2C_GetStatus(I2C,I2C_FLAG_MDGSendAck) != SET);
		*pBuffer=I2C_ReceiveData(I2C);
		pBuffer++;
	}
	/******************ֹͣλ***************/
	I2C_GenerateSTOP(I2C,ENABLE);
}

int main (void)
{
  int i=0;
  u8 arry_write[8]={0};
	u8 arry_read[8]={0};
	
	UART_Driver();
	I2C_GPIO_Config();
	I2C_Driver();
	
	for(;i<sizeof(arry_write);i++)
	{
		arry_write[i]=i*2;
	}
	printf("start to write\r\n");
	I2C_EE_Write(arry_write,0x00,0xA0, sizeof(arry_write));

	printf("start to read\r\n");
	I2C_EE_Read(arry_read,0x00,0xA0,sizeof(arry_read));

	for(i=0;i<sizeof(arry_read);i++)
	{
		printf("%X	",arry_read[i]);
	}
	printf("\r\n");
	while(1);
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


