/******************************************************************************
  * @file   PT32x033x_conf.h
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2020/10/19
  * @brief    
  *          
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/

  

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef PT32x033x_CONF_H
#define PT32x033x_CONF_H

/* Includes ------------------------------------------------------------------*/
/* Comment the line below to disable peripheral header file inclusion */
#include "PT32x033x_gpio.h"
#include "PT32x033x_tim.h"
#include "PT32x033x_misc.h"
#include "PT32x033x_uart.h"
#include "PT32x033x_pwm.h"
#include "PT32x033x_wdg.h"
#include "PT32x033x_i2c.h"
#include "PT32x033x_spi.h"
#include "PT32x033x_crc.h"
#include "PT32x033x_rtc.h"
#include "PT32x033x_ifmc.h"
#include "PT32x033x_adc.h"
#include "PT32x033x_dac.h"
#include "PT32x033x_lcd.h"
#include "PT32x033x_beep.h"
#include "PT32x033x_pwr.h"
#include "PT32x033x_rcc.h"
#include "PT32x033x_id.h"
#include "PT32x033x_ldac.h"
#include "PT32x033x_exti.h"
#include "PT32x033x_opa.h"
#include "PT32x033x_cmp.h"

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/


#ifdef  USE_FULL_ASSERT

/**
  * @brief  The assert_param macro is used for function's parameters check.
  * @param  expr: If expr is false, it calls assert_failed function which reports 
  *         the name of the source file and the source line number of the call 
  *         that failed. If expr is true, it returns no value.
  * @retval None
  */
  #define assert_param(expr) ((expr) ? (void)0 : assert_failed((uint8_t *)__FILE__, __LINE__))
/* Exported functions ------------------------------------------------------- */
  void assert_failed(uint8_t* file, u32 line);
#else
  #define assert_param(expr) ((void)0)
#endif /* USE_FULL_ASSERT */

#endif 


