/******************************************************************************
  * @Example RTC
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   3RTCӣĿÿ3ӽλһRTCʱӣͨLEDʵ3˸һεĹ
  *          
  ******************************************************************************
  * @attention	
  *							
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/

#include "PT32x033x.h"

extern u8 rtc_flag;
u8 error_code=0,temp=0;


void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;	//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;	//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	//ƫ
	GPIO_Init(GPIOC, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
	GPIO_ResetBits(GPIOC, GPIO_Pin_6);			//ÿ⺯GPIO״̬
}

void RTC_Driver(void)
{
	RTC_InitTypeDef  RTC_InitStruct;
	
	RTC_Calendar pTIME;
	
	NVIC_DisableIRQ(RTC_IRQn);
	NVIC_ClearPendingIRQ(RTC_IRQn);    // clear pending before enable int
	NVIC_EnableIRQ(RTC_IRQn);          /* Enable RTC Interrupt */
	RTC_ITConfig(RTC_IE_ALME,ENABLE);

	RTC_ClearFlag(RTC_SR2_CSEC|RTC_SR2_CMIN|RTC_SR2_CHOUR|RTC_SR2_DAY|RTC_SR2_MON|RTC_SR2_ALM);
	RTC_StructInit(&RTC_InitStruct);
	RTC_Init(&RTC_InitStruct);
	
	RTC_UnlockCMD(ENABLE);

	pTIME.Year=1;
	pTIME.Month=1;
	pTIME.Day=1;
	pTIME.Second=20;
	pTIME.Minute=18;
	pTIME.Hour=18;
	pTIME.TimeFormat=RTC_TimeFormat_12;//12Сʱʽ
	pTIME.PM=RTC_HOUR_AM;
	RTC_SetCalendarTime(&pTIME);
	
	RTC->ASEC=0x22;
	RTC->AMIN=0x18;
	RTC->AHOUR=0x18;
	RTC->AHOUR|=RTC_HOUR_AM<<8;		
	RTC_UnlockCMD(DISABLE);
	
	RTC_CMD(ENABLE);
}

int main (void)
{
	RTC_Calendar pTIME;
	LED_Driver();
	RTC_Driver();
	
	while(1)
	{
		if(rtc_flag==1)
		{
			rtc_flag=0;
	    RTC_UnlockCMD(ENABLE);

			while((RTC_GetFlagStatus(RTC_FLAG_LockSync)));

			pTIME.Second=20;
			pTIME.Minute=18;
			pTIME.Hour=18;
			pTIME.TimeFormat=RTC_TimeFormat_12;
	    pTIME.PM=RTC_HOUR_AM;
			RTC_SetCalendarTime(&pTIME);
			
			RTC->ASEC=0x22;
			RTC->AMIN=0x18;
			RTC->AHOUR=0x18;
			RTC->AHOUR|=RTC_HOUR_AM<<8;

			RTC_UnlockCMD(DISABLE);

			while((RTC_GetFlagStatus(RTC_FLAG_UnLockSync)));
			temp++;
			if(temp==1)	GPIO_SetBits(GPIOC, GPIO_Pin_6);		//high
			if(temp==2)
			{
				temp=0;
				GPIO_ResetBits(GPIOC, GPIO_Pin_6);		//low
			}
		}
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


