/******************************************************************************
  * @Example DAC
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ͨDAC_Vout1/2 BG2v ѹ
  *          
  ******************************************************************************
  * @attention	
  *				
  *		
  *		
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"

void DAC_Mode_Config(void)
{
	DAC_InitTypeDef DAC_InitStruct;
	DAC_StructInit(&DAC_InitStruct);
	DAC_Init(&DAC_InitStruct);
	DAC_SetData(2048);
	DAC_Cmd(ENABLE);
	DAC_Wait_For_Transformat_OK();
}


int main (void)
{
	PWR->VRFR=PWR_VRFR_EN;
	DAC_Mode_Config();
	while(1)
	{
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


