/******************************************************************************
  * @Example LOW_POWER
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ϵ˯ģʽUserٷſԻ˯ߣʱһʱֽ˯ߣͨйĹ۲
  *          
  ******************************************************************************
  * @attention	
  *				0ŷķR6MAIN POWERԲоƬ
  *				ʹø̲оƬʱӦþⲿ·Ķ⹦
  *				ʹø̲оƬʱӦýؿɵR290V
  *				ʹø̲оƬʱ粻ȥLEDӵR12R13R14⹦
  *				ʹø̲оƬʱӦýɵI/OԽʡģ
  *				ʹø̲оƬʱߵӽĹ
  *				ⲿж˯ߣ˯ʱ͹Ϊ0.8uAUserĵR10©PD3Ĺ1.2uA
  *				˯ģʽ£ⲿʽֻΪGPIOTI_Trigger_Rising_Falling,GPIOTI_Trigger_High_Level,GPIOTI_Trigger_Low_Level
  *				
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"

void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<50; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
  GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}


void Wake_Key_Init(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;
	GPIO_InitTypeDef GPIO_InitStructure;					//һGPIO_InitTypeDef͵Ľṹ
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;	//ģʽΪ
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_Init(GPIOD, &GPIO_InitStructure);			//ÿ⺯ʼGPIO
	
	//GPIO˿жϴѡ
	EXTI_TriTypeConfig(EXTID,EXTI_Pin_3, EXTI_Trigger_LowLevel);
	EXTI_ITConfig(EXTID,EXTI_IT_3,ENABLE);

	/*ʹGPIONVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = EXTID_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
}

void Key_Wake_Sleep(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	GPIO_AnaRemapConfig(AFIOA, AFIO_Pin_All, DISABLE);
	GPIO_AnaRemapConfig(AFIOB, AFIO_Pin_All, DISABLE);
	GPIO_AnaRemapConfig(AFIOC, AFIO_Pin_All, DISABLE);
	GPIO_AnaRemapConfig(AFIOD, AFIO_Pin_All, DISABLE);
	
	GPIO_DigRemapConfig(AFIOA, (AFIO_Pin_All&(~AFIO_Pin_13)&(~AFIO_Pin_14)),AFIO_AF_None,DISABLE);	//SWDӿڲ
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_All,AFIO_AF_None,DISABLE);
	GPIO_DigRemapConfig(AFIOC, AFIO_Pin_All,AFIO_AF_None,DISABLE);
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_All,AFIO_AF_None,DISABLE);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All&(~GPIO_Pin_3);
	GPIO_Init(GPIOD, &GPIO_InitStructure);	
	
	PWR_EnterSTANDBYMode(PWR_STANDBYEntry_WFI);	//˯ߣжϻ
	Software_Delay();
}


int main (void)
{
	Wake_Key_Init();
	Software_Delay();						//ϵӦʱһʱ䣬ܹرRC 32Khz
	
	RCC_OscillatorCmd(Oscillator_LSI,DISABLE);//رĬʹܵڲRC 32K Խʡ
	while(1)
	{
		Key_Wake_Sleep();
		Software_Delay();	
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


