/******************************************************************************
  * @Example LVD
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   	ⲿԴ<=3.5VʱԴ͵ѹ¼"PVD"жϡλԶ־PC5LEDƵ
  *				ֱԴ>=3.6VPVD˳жϣPC5LEDϨ
  *          
  ******************************************************************************
  * @attention	
  *			ʹø̣
  *			ԴΪʹⲿԴʱҪȷDemoϵJ6J5̽ӣJ6VOUTGNDŽӵⲿԴ
  *			ԴΪʹðصԴʱҪȷDemoϵJ6J5̽ӣͨJ2л3.3V5VԴԹ۲쵽LED̵ƵϨ
  *			HIGH_LVDжӲԶж⴦񣬿ڽPVDжϺʧLVDжϣٽʹ
  *			PVDֵΪ2.0V1.7VʱPVDֻܹλܹжϡ
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"


u8 high_pvd_flag=0;

void GPIO_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;	//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;	//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	//ƫ
	GPIO_Init(GPIOC, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
	GPIO_SetBits(GPIOC, GPIO_Pin_5);			//ÿ⺯GPIO״̬
}


/*******************************************************************************
*Function:	PVD_Driver
*Description:	HIGH_LVDģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void PVD_Driver(void)
{
	NVIC_EnableIRQ(PVD_IRQn);
	PWR_PVDLevelConfig(PWR_PVDLevel_6);//PVDֵΪ3.5V
	PWR_PVDCmd(ENABLE);				//PVDʹ
}

int main (void)
{
	GPIO_Driver();
	PVD_Driver();
	while(1)
	{
		if(high_pvd_flag==1)
		{
			high_pvd_flag=0;
			GPIO_SetBits(GPIOC, GPIO_Pin_5);			//high
		}
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


