/******************************************************************************
  * @Example LVD
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   	¼ⲿԴС3.5VУӭ䣬LEDƵ
  *          	ⲿԴ<=3.5VоƬȴԴС3.5vλ,λʱӭ
  *          	
  ******************************************************************************
  * @attention	
  *			ԸӦʹⲿԴҪȷDemoϵJ6J5̽ӣJ6VOUTGNDŽӵⲿԴ
  *			PVDֵΪ2.0V1.7VʱPVDֻܹλܹжϡ
  *			PVDλϢоƬ
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"


void GPIO_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;	//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6;	//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	//ƫ
	GPIO_Init(GPIOC, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
	GPIO_SetBits(GPIOC, GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6);	//ÿ⺯GPIO״̬
}


/*******************************************************************************
*Function:	PVD_Driver
*Description:	PVDģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void HIGH_LVD_Driver(void)
{
	RCC_RestConfig(RCC_Reset_PDRE,ENABLE);	//PVD λʹ
	PWR_PVDLevelConfig(PWR_PVDLevel_6);	//PVDֵΪ3.5V
	PWR_PVDCmd(ENABLE);					//PVDʹ
}
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX0
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX0
}
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}
int main (void)
{
	UART_Driver();
	HIGH_LVD_Driver();
	GPIO_Driver();
	printf("ӭʹPT32x033xϵ,ϵͳʼ\r\n");
	GPIO_ResetBits(GPIOC, GPIO_Pin_5);		//Low
	while(1);
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


