/******************************************************************************
  * @Example SPI
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ʹSPIԷգʹôϢ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλУ
  *				ʹø:
  *							
  *							SPI_MOSI0SPI_MISO0̽PB1PB3ػշ
  *							PB2 --> SPI_CS1
  *							PB0 --> SPI_SCK1
  *							PB1 --> SPI_MOSI1
  *							PB3 --> SPI_MISO1
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"


void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX0
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*
ʼSPIܽ
*/

void SPI_GPIO_Config(void)
{
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_2, AFIO_AF_2,ENABLE);	//SPI_CSֹܸ
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_0, AFIO_AF_2,ENABLE);	//SPI_SCKֹܸ
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_1, AFIO_AF_2,ENABLE);	//SPI_MOSIֹܸ
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_3, AFIO_AF_2,ENABLE);	//SPI_MISOֹܸ
}


void SPI_MasterMode_Config(SPI_TypeDef* SPIx)
{
	SPI_InitTypeDef  SPI_InitStructure;						//һSPI_InitTypeDef͵Ľṹ

	SPI_StructInit(&SPI_InitStructure);						//ʹĬֵʼSPI_InitStructure
	
	/* SPI ģʽ */
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;		//Ϊģʽ
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;		//֡
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;				//ʱӼԣ״̬ʱSCKָߵƽ
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;			//ʱλݲӵڶʱӱؿʼ
	SPI_InitStructure.SPI_CSS = 0X4;//SPI_CSS_Soft;				//CSƣĬϳʼֵΪߵƽ
	SPI_InitStructure.SPI_Prescaler = 0;					//SPIʱӷƵϵ
	SPI_InitStructure.SPI_BaudRatePrescaler = 16;			//SPIԤƵ f(sck)=f(pclk)/(SPI_Prescaler*(1+SPI_Prescaler))
    
	SPI_Init(SPIx, &SPI_InitStructure);						//ʼSPI
	SPI_CSInternalSoftwareConfig(SPIx, SPI_NSSInternalSoft_Set);		//ƬѡźſƣCSߵƽ
	
	SPI_Cmd(SPIx, ENABLE);									//ʹSPI
}

int main (void)
{
	u8 i = 0;
	u8 tx_data[5]={1,2,3,4,5};
	u8 rx_data[5]={0};
	
	UART_GPIO_Config();
	UART_Mode_Config();
	SPI_GPIO_Config();
	SPI_MasterMode_Config(SPI1);
	while(i<5)
	{
		while(!SPI_GetFlagStatus(SPI1,SPI_FLAG_TXE));	//FIFOΪ
		SPI_SendData(SPI1	,tx_data[i]);
		while(!SPI_GetFlagStatus(SPI1,SPI_FLAG_RXNE));	//FIFOǿ
		rx_data[i] = SPI_ReceiveData(SPI1);			
		i++;
	}
	i=0;
	while(i<5)
	{
		Software_Delay();
		printf("rx_data[%d] = %d \r\n",i,rx_data[i]);		
		i++;
	}	
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
