/******************************************************************************
  * @Example OPAOffset
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ԶOPAУ׼У׼ֵд
  *          
  ******************************************************************************
  * @attention	
  *	У׼̣
	* OPAΪȽģʽµУ׼ģʽΪģʽ;
	* DACοԴΪBG2V0DAC300mVΪOPA룬ڲѾһ;
	* ADCΪͨ7(OPA0_OUT)ͨ8(OPA1_OUT)16ƵΪBG2V0;
  * ѭд벻ͬУ׼ֵOPA OUTƽתʱתǰУ׼ֵΪУ׼
	* ʹADCɼУ׼ֵӦӽDAC߼ΪУ׼ֵ
	* ʱҪʹⲿ߽OPANOUT̽ӡ
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"
#include "math.h"
//#define  Debug_Printf 0
#define  DAC_CONFIG_PARAM						614				//CIDĸ16λУ׼300mvDACӦ

uint16_t 				cnt_1ms = 0;

__IO u8 				time_over = 0;																	//ʱ2	ÿʱ䴰 ʱflag
__IO u32 				time_count1 = 0;																//ʱ2	ÿʱ䴰 
__IO u32 				out_time = 0;																		//ʱ2	ÿʱ䴰 óʱʱ


void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}
/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX0
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

void OPA_CalibMode(uint8_t OPA_CH, FunctionalState NewState)
{
	/* Check the parameters */

  OPA_TypeDef* OPAx;
	if (OPA_CH==0)
	{	
		OPAx = OPA0;
	}
	else
	{
		OPAx = OPA1;
	}
	if (NewState != DISABLE)
	{
		OPAx->CR2 &= ((uint32_t)0xFFFFFFFE);//Ƚģʽ
		OPAx->CR2 |= ((uint32_t)0x06);  //У׼ģʽ
		
		GPIO_AnaRemapConfig(AFIOB, GPIO_Pin_13, DISABLE); 	//	OPA0_OUT & AIN7
	  GPIO_AnaRemapConfig(AFIOC, GPIO_Pin_0,  DISABLE);		//  OPA0_N
	
	  GPIO_AnaRemapConfig(AFIOD, GPIO_Pin_5,  DISABLE);		//  OPA1_OUT & AIN8			
	  GPIO_AnaRemapConfig(AFIOC, GPIO_Pin_1,  DISABLE);		//  OPA1_N	
	}
	else
	{
		OPAx->CR2 &=0xFFFFFFFD;//ģʽ
		OPAx->CR2 |=0x01; //OPAģʽ
	  GPIO_AnaRemapConfig(AFIOB, GPIO_Pin_13, ENABLE); 	//	OPA0_OUT & AIN7
	  GPIO_AnaRemapConfig(AFIOC, GPIO_Pin_0,  ENABLE);		//  OPA0_N
	
	  GPIO_AnaRemapConfig(AFIOD, GPIO_Pin_5,  ENABLE);		//  OPA1_OUT & AIN8			
	  GPIO_AnaRemapConfig(AFIOC, GPIO_Pin_1,  ENABLE);		//  OPA1_N	
	}
}

void OPA_Config(void)
{
	OPA_InitTypeDef opa_initstruct;
																			
	GPIO_AnaRemapConfig(AFIOC, GPIO_Pin_13, ENABLE);		//  AIN0(ɼDAC_VOUTѹ)						
	GPIO_AnaRemapConfig(AFIOD, GPIO_Pin_6, ENABLE);		//  ADVRH2Vѹ)
				
	/*ʹ·OPAѡDACΪP*/
	OPA_StructInit(&opa_initstruct);
	OPA_Init(OPA1, &opa_initstruct);
	OPA_Cmd(OPA1, ENABLE);
	OPA_StructInit(&opa_initstruct);
	OPA_Init(OPA0, &opa_initstruct);
	OPA_Cmd(OPA0, ENABLE);
}

	void ADC_StructInit(ADC_InitTypeDef* ADC_InitStruct)
{
	ADC_InitStruct->ADC_Prescaler = ADC_CLK_DIV2;							//ADCƵ8/2=4 MHz
	ADC_InitStruct->ADC_MODE = ADC_MODE_Single;						//תģʽ
	ADC_InitStruct->ADC_TIMS=ADC_TIMS_TIM0Trgo;						//ʱԴѡTIM0¼
	ADC_InitStruct->ADC_ALIGN = ADC_DataAlign_Right;					//Ҷ
	ADC_InitStruct->ADC_Channel=ADC_Channel_0;						//ͨ0,PC13
	ADC_InitStruct->ADC_ReferencePositive= ADC_ReferencePositive_BG2V0;	//ѡBG2V0Ϊ˲οƽ
	ADC_InitStruct->ADC_AnalogChannel=ADC_AnalogChannel_BG1v2;
}

void Sys_ADC_Config(void)
{
	ADC_InitTypeDef adc_initstruct;
	ADC_StructInit(&adc_initstruct);
	adc_initstruct.ADC_Prescaler=ADC_CLK_DIV16;
	adc_initstruct.ADC_ReferencePositive=ADC_ReferencePositive_BG2V0|ADC_ReferencePositive_AVREF;
	ADC_Init(ADC, &adc_initstruct);
	ADC_SetSampleTime(ADC, 0x32);//òʣ
}

uint32_t Filtter_Get_ADCValue(uint32_t ADC_CH)	//ȡADCֵ
{
	uint32_t 	AVE = 0, ADC_Count = 0, ADC_DATA[10], max = 0, min = 0;
	uint32_t  min_tag=0,max_tag=0;
	ADC_ChannelConfig(ADC, ADC_CH);																		//ADCתͨ
	for(ADC_Count = 0; ADC_Count < 10; ADC_Count++)
	{
		ADC_Cmd(ADC, ENABLE);																						//ADC蹦
		while(!ADC_GetFlagStatus(ADC, ADC_FLAG_RDY));									  //ȴADC
		ADC_ConversionConfig(ADC,ENABLE);
		while(!ADC_GetFlagStatus(ADC, ADC_FLAG_EOC));										//ȴADC
		ADC_DATA[ADC_Count] = ADC_GetConversionValue(ADC);							//ȡ
	}
	ADC_Cmd(ADC, DISABLE);
	max = ADC_DATA[0];
	min = ADC_DATA[0];
	for(ADC_Count = 0; ADC_Count < 10; ADC_Count++)
	{
		if(ADC_DATA[ADC_Count] > max)	
		{
			max = ADC_DATA[ADC_Count];
			max_tag = ADC_Count;
		}
		if(ADC_DATA[ADC_Count] < min)	
		{
			min = ADC_DATA[ADC_Count];
			min_tag = ADC_Count;			
		}
		AVE += ADC_DATA[ADC_Count];
	}
	AVE -= max;
	AVE -= min;

 #ifdef  Debug_Printf	
	if(ADC_CH == ADC_Channel_0)
  printf("DAC Channel \r\n");
  else if (ADC_CH == ADC_Channel_7)
  printf("OPA0 Channel \r\n");
  else if (ADC_CH == ADC_Channel_8)	
  printf("OPA1 Channel \r\n");
  else
	printf("ADC Channel:%x\r\n",ADC_CH);		
	for(ADC_Count = 0; ADC_Count < 10; ADC_Count++)
	{
    if((ADC_Count!=min_tag)&&(ADC_Count!=max_tag))
    printf("%d\r\n",ADC_DATA[ADC_Count]);
	}
		
 #endif		
	return AVE;
}

void Sys_DAC_Config(void)
{
	uint16_t DAC_Value;
	DAC_InitTypeDef dac_initstruct;
	DAC_StructInit(&dac_initstruct);
	DAC_Init(&dac_initstruct);
	DAC_SetData(DAC_CONFIG_PARAM);
	PWR->VRFR=PWR_VRFR_EN; //BG2V0
	DAC_Cmd(ENABLE);
	DAC_Wait_For_Transformat_OK();
}


/*
	дУ׼ֵ
*/
void OPA_CalibValue_Set(uint32_t OPA_CH, uint32_t Offset_Value)
{
	uint32_t Reg_Tmp=0;
  OPA_TypeDef* OPAx;
	if (OPA_CH==0)
	OPAx = OPA0;
	else
  OPAx = OPA1;
	
	Reg_Tmp = OPAx->CR2;		
	Reg_Tmp &= 0xFFFFFE0F;
	Reg_Tmp  |= ((uint32_t)((0xACDE<<16)|(Offset_Value) << 4 ));
	/* Write to OPAx CR2 */	
	OPAx->CR2 = Reg_Tmp;
}
uint8_t Get_CMPStau(uint8_t OPA_CHN)
{
  OPA_TypeDef* OPAx;
	if (OPA_CHN==0)
	OPAx = OPA0;
	else
  OPAx = OPA1;
  return ((OPAx->CR1&0x02)>>1);

}
void Sys_TIMER_Config(void)
{
	TIM_TimeBaseInitTypeDef TimeBaseInit;
	NVIC_InitTypeDef NVIC_InitStruct;
	/*ʹTIMER2NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = TIM2_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	/* CNTʱ = Fcksys/(psc+1)*/
	TimeBaseInit.Prescaler = 0;
	/*ģʽΪϼ*/
	TimeBaseInit.CounterMode = TIM_CounterMode_UP;
	/*ƥĴ,ۼMR0+1Ƶʺһ»ж*/
	TimeBaseInit.MatchValue = 7999;
	/*CountMR0,λ*/
	TimeBaseInit.OVRSTEN = ENABLE;
	/*ʼʱ*/
	TIM_TimeBaseInit(TIM2, &TimeBaseInit);
	/*ʹܶʱTCؼĴMR0ƥʱж*/
	TIM_ITConfig(TIM2,TIMx_IE_UIE, ENABLE);
	/*PWM*/
	TIM_Cmd(TIM2, ENABLE);
}
void SysTick_Delay_Ms( __IO uint32_t ms)
{
	uint32_t i;
	SysTick_Config(clk_get_sysclk() / 1000);
	for(i = 0; i < ms; i++)
	{
		/* ֵС0ʱCRTLĴλ161*/
		/* 1ʱȡλ0*/
		while( !((SysTick->CTRL) & (1 << 16)) );
	}
	/* رSysTickʱ*/
	SysTick->CTRL &= ~ SysTick_CTRL_ENABLE_Msk;
}

	u32 DAC_OUT=0,Test_Loop=0,Calib_Step=0,ADC_Code[2][2],Offset,x,y,z;
	unsigned char OPA_CHN=0,i=0;
	u8 offsetx[2][100]={0};
	u8 error_OPA[2][2][100]={0};  
	u8 offset_OPA[2][2][100]={0};
	u8 offset2_OPA[2][100]={0};
	u8 best_offset[2]={0};
	u8 index0=0,index1=0;
	u8 temp0=0,temp1=0;
int main (void)
{	
	UART_Driver();
	printf("PT32x033xûģʽOPAoffset\r\n");
	Sys_ADC_Config();
	Sys_DAC_Config();
	OPA_Config();	
	Sys_TIMER_Config();

	DAC_OUT=Filtter_Get_ADCValue(ADC_Channel_0);	
	for(OPA_CHN=0;OPA_CHN<2;OPA_CHN++)
	{						
		/*************У׼OPA****************/						
		for(Test_Loop =0;Test_Loop<100;Test_Loop++)
		{
			OPA_CalibMode(OPA_CHN,ENABLE);
			OPA_CalibValue_Set(OPA_CHN,18);
			x=Get_CMPStau(OPA_CHN);
			for(Calib_Step=18;Calib_Step>=1;Calib_Step--)
			{
				OPA_CalibValue_Set(OPA_CHN,Calib_Step);
				SysTick_Delay_Ms(1);								
				x=Get_CMPStau(OPA_CHN);
				if(x!=y)
				{
					Offset=Calib_Step;
					offset_OPA[OPA_CHN][0][Test_Loop]=Offset;//1#ѡ
					offset_OPA[OPA_CHN][1][Test_Loop]=Offset+1;//2#ѡ
					break ;
			  }
		  }
				/*************ջУ׼OPA***********/
			 OPA_CalibMode(OPA_CHN,DISABLE);
			 for(i=0;i<2;i++)
			 {
				#ifdef  Debug_Printf	
				printf ("%X \r\n",offset_OPA[OPA_CHN][i][Test_Loop]);
				#endif								 
				OPA_CalibValue_Set(OPA_CHN,offset_OPA[OPA_CHN][i][Test_Loop]);								
				ADC_Code[OPA_CHN][i]=Filtter_Get_ADCValue((OPA_CHN==0 ? ADC_Channel_7 : ADC_Channel_8));	 
			}
			 error_OPA[OPA_CHN][0][Test_Loop]=abs((int)ADC_Code[OPA_CHN][0]-(int)DAC_OUT);
			 error_OPA[OPA_CHN][1][Test_Loop]=abs((int)ADC_Code[OPA_CHN][1]-(int)DAC_OUT);	
			 if(error_OPA[OPA_CHN][0][Test_Loop]>error_OPA[OPA_CHN][1][Test_Loop])
			 {
					 offsetx[OPA_CHN][Test_Loop] = offset_OPA[OPA_CHN][1][Test_Loop];
			 }
			 else	
			 {							 
				offsetx[OPA_CHN][Test_Loop] = offset_OPA[OPA_CHN][0][Test_Loop];
			 }
	  }
	}
	for(OPA_CHN=0;OPA_CHN<2;OPA_CHN++)
	{
		for(Test_Loop=0;Test_Loop<100;Test_Loop++)
		{
			/**********************У׼ֵֵĸɸѡֵ*************************/
			if(offsetx[OPA_CHN][Test_Loop] == offset_OPA[OPA_CHN][0][Test_Loop])
			{
				index0++;
				temp0 = offsetx[OPA_CHN][Test_Loop];
			}
			else if(offsetx[OPA_CHN][Test_Loop] == offset_OPA[OPA_CHN][1][Test_Loop])
			{
				index1++;
				temp1 = offsetx[OPA_CHN][Test_Loop];
			}
		}
		if(index0 >= index1)
		{
			best_offset[OPA_CHN] = temp0;
		}
		else
		{
			best_offset[OPA_CHN] = temp1;
		}
		Test_Loop = 0;
		printf("OPA[%d],У׼ֵ1%X,ִ%d,У׼ֵ2%X,ִ%d,ѡУ׼ֵ%X\r\n",OPA_CHN,offset_OPA[OPA_CHN][0][Test_Loop],index0,offset_OPA[OPA_CHN][1][Test_Loop],index1,best_offset[OPA_CHN]);

		index0 = 0;
		index1 = 0;
		temp0 = 0;
		temp1 = 0;

		/**********************OPAдֵ**************************/
		OPA_CalibMode(OPA_CHN,DISABLE);
		OPA_CalibValue_Set(OPA_CHN,best_offset[OPA_CHN]);
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
